package PVS.HyperProf;
//
// Copyright (C) 1996 by Vladimir Bulatov <V.Bulatov@ic.ac.uk>.  
//        All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

import PVS.Utils.Comparator;
import PVS.Utils.Fmt;


class CallerEntry extends Object implements Comparator{

  ProfEntry entry;
  int time, calls;
  Main mainframe;

  CallerEntry(ProfEntry entry, int time, int calls,Main mainframe){
    this.time = time;
    this.calls = calls;
    this.entry = entry;
    this.mainframe = mainframe;
  }

  public int compare(Object fst, Object snd){
    if(mainframe.sortType == Main.SORT_BY_TIME)
      return  ((CallerEntry)snd).time - ((CallerEntry)fst).time;    
    else if(mainframe.sortType == Main.SORT_BY_NAME)
      return  ((CallerEntry)fst).entry.
	name.shortName.compareTo(((CallerEntry)snd).entry.name.shortName);
    return 0;
  }

  public String toString(){
    if(mainframe.shortOutput)
      return ""+
	((mainframe.units == Main.ABSOLUTE_UNITS)?
	 (Fmt.fmt(time,6)+" "+(Fmt.fmt(ProfInfo.current_time,6))):
	 (Fmt.fmt((100.*time/ProfInfo.total_time),5,3)+"% "+
	 Fmt.fmt((100.*ProfInfo.current_time/ProfInfo.total_time),5,3)+"% "))+
	   "/"+Fmt.fmt(calls,6,Fmt.LJ) + entry.name.shortName;  
    else 
      return ""+
	((mainframe.units == Main.ABSOLUTE_UNITS)?
	 (Fmt.fmt(time,6)+" "+(Fmt.fmt(ProfInfo.current_time,6))):
	 (Fmt.fmt((100.*time/ProfInfo.total_time),5,3)+"% "+
	 Fmt.fmt((100.*ProfInfo.current_time/ProfInfo.total_time),5,3)+"% "))+
 	   "/"+Fmt.fmt(calls,7,Fmt.LJ)+
	     entry.name.packageName + entry.name.shortName;
  }
  
} 
