package PVS.Utils;
//
// Copyright (C) 1996 by Vladimir Bulatov <V.Bulatov@ic.ac.uk>.  
//        All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

public class MathExt{

  /**
    returns hyperbolic tangence
   */

  public static double tanh(double x){
    x = Math.exp(x); 
    x *= x;
    return (x-1)/(x+1);
  }

  public static double cosh(double x){
    double y = Math.exp(x);
    return (y+1./y)/2;
  }

  public static double sinh(double x){
    double y = Math.exp(x);
    return (y-1./y)/2;
  }

  public static double atanh(double x){
    return 0.5*Math.log((1+x)/(1-x));
  }

  public static double acosh(double x){
    return Math.log(x+Math.sqrt(x*x-1));
  }


  public static double sqr(double x){
    return x*x;
  }
  
  public static void main(String[] args){
    double x = 1;
    System.out.println("cosh():"+MathExt.cosh(x));
    System.out.println("acosh(cosh()):"+MathExt.acosh(MathExt.cosh(x)));
  }
}

